<?php
/*
Plugin Name: GetYourBill
Plugin URI:  https://www.getyourbill.com/getyourbill
Description: Create your invoices with GetYourBill
Version: 1.1.8
Text Domain: wc_getyourbill
Author: GetYourBill
License: GPL2
License URI : http://www.gnu.org/licenses/gpl-2.0.html
*/

define( 'GetYourBill', true );
define( 'GetYourBillDEVMOD', (isset($_COOKIE["GetYourBillDEVMOD"]))?true:false );
define( 'TABGetYourBillNAME', "GetYourBill" );
define( 'GetYourBillImposta', "GetYourBillImposta" );
define( 'GetYourBillPATH', plugin_dir_path( __FILE__ ) );
define( 'GetYourBillURL', plugin_dir_url( __DIR__ )."getyourbill/" );
define( 'GetYourBillFILE',  __FILE__ );
define( 'GetYourBillApiUrlTEST', "https://coretest.getyourbill.com/api/v3/" );
define( 'GetYourBillApiUrlLIVE', "https://core.getyourbill.com/api/v3/" );
$gyb_isonline = get_option( "wc_settings_getyourbill_settings_config_isonline" , "yes" );
if( $gyb_isonline === "yes" ){
  define( 'GetYourBillApiUrl', GetYourBillApiUrlTEST );
}else{
  define( 'GetYourBillApiUrl', GetYourBillApiUrlLIVE );
}
define( 'GetYourBillSupportUrl', "https://api.mab21.com/getyourbill/" );
define( 'GetYourBillUpdateUrl', "https://api.mab21.com/wp/" );
define( 'GetYourBillSUPPORT', "WRlbnRpdHkvY2xhaW1zL3JvbGUiOiJERVZJQ0UiLCJodHR" );
define( 'GetYour24H', DAY_IN_SECONDS*2 );
define( 'GetYourLimitResolveErroreOnLoop', 5 );
define( 'GetYourBillCronStatusTime', 1 );
define( 'GetYourBillCronErrorSendTime', 1 );
define( 'GetYourBillCronStatusTimeProcessiong', 5 );

if (!defined('ABSPATH') || !function_exists('is_admin')) {
    header('Status: 403 Forbidden');
    header('HTTP/1.1 403 Forbidden');
    exit();
}

if (!class_exists("GetYourBill")) :

	include_once(GetYourBillPATH.'/inc/defined.php');
	include_once(GetYourBillPATH.'/inc/messaggi.php');
	require_once(ABSPATH.'wp-includes/pluggable.php');
	include_once GetYourBillPATH."/src/WC_Settings_GetyourbillTabs.php";
	require_once GetYourBillPATH."/autoload.php";
  if( !function_exists('get_plugin_data') ){
    require_once( ABSPATH . 'wp-admin/includes/plugin.php' );
  }
	class GetYourBill {
		public $vs = "1.1.8";
		public $WC_Settings_GetyourbillTabs = null;
		public  $id	= "getyourbill";
		public function __construct()
		{
			$plugin_data = get_plugin_data( __FILE__ );
			$this->vs = $plugin_data["Version"];
      add_action( 'plugins_loaded', array( $this, 'getyourbill_load_textdomain' ) );
      if ( is_plugin_active('woocommerce/woocommerce.php') ) {
        add_filter( 'load_textdomain_mofile', array( $this, 'get_your_bill_load_my_own_textdomain'), 10, 2 );

   			$this->WC_Settings_GetyourbillTabs = new WC_Settings_GetyourbillTabs();
  			register_activation_hook( __FILE__, array($this, 'getyourbill_register_activation_hook') );
  			register_deactivation_hook( __FILE__, array($this, 'getyourbill_register_deactivation_hook'));
  			add_action( 'admin_head', array($this, 'custom_admin_js'));

        //add_filter( 'getyourbill_invoice_template', array( $this, 'getyourbill_invoice_template' ) );


  			add_action('admin_notices', function() {
  				if( !class_exists('WooCommerce') ){
  					echo printf( '<div class="%1$s"><p>%2$s</p></div>', 'notice notice-error', __('Richiede il plugin WooCommerce', 'wc_getyourbill') );
  				}else{
  					$this->WC_Settings_GetyourbillTabs->getyourbill_notice();
  				}

          if (!function_exists ( 'curl_version' )) {
              echo printf( '<div class="%1$s"><p>%2$s</p></div>', 'notice notice-error', __('Richiede il plugin WooCommerce', 'wc_getyourbill') );
          }

  			});

  			add_action('admin_enqueue_scripts',  array($this, 'getyourbill_admin_style'));
  			add_action('wp_enqueue_scripts',  array($this, 'getyourbill_for_setting_up_scripts') );
  			add_action( 'wp_ajax_getyourbill_get_campi_by_user',  array($this, 'getyourbill_get_campi_by_user') ); // only loged
  			add_action( 'wp_ajax_getyourbill_info',  array($this, 'getyourbill_get_get_yourbill_user_info_by') ); // only loged
  			add_action( 'wp_ajax_getyourbill_add_tax',  array($this, 'getyourbill_add_tax') ); // only loged

  			add_filter( 'plugins_api', array($this, 'getyourbill_plugin_info'), 20, 3);
  			add_filter( 'site_transient_update_plugins', array($this, 'getyourbill_push_update') );
  			add_action( 'upgrader_process_complete', array($this, 'getyourbill_after_update'), 10, 2 );
  			add_action( 'init', array($this, 'GetYourBillImpostType'));
  			if( is_user_logged_in() && is_admin() ){
  				add_action('init', function() {
  					if( isset($_GET["gybevent"]) && $_GET["gybevent"] == "gybeventupdate" ){
  						$this->getyourbill_checked_manual();
  					}
  				});
  			}
  			add_action( 'init', function(){
          if( isset( $_GET["generate_getyourbill_template"]) && isset( $_GET["order_ids"]) ){
      			if( is_user_logged_in() && is_admin() ){
              return apply_filters( 'getyourbill_invoice_template', $_GET["order_ids"] );
            }
          }
        });

        add_action("add_meta_boxes", array($this, "add_getyourbill_meta_box"));
        add_action( 'save_post',  array($this, 'getyourbill_save_postdata') );
      }else if ( !is_plugin_active('woocommerce/woocommerce.php') && is_plugin_active('getyourbill/getyourbill.php') ) {
          deactivate_plugins("getyourbill/getyourbill.php", true);
      }

		}
    function get_your_bill_load_my_own_textdomain( $mo, $textdomain ) {

      $plugin_domain = 'wc_getyourbill';

  		$mopath = trailingslashit( dirname( $mo ) );
  		$mofile = basename( $mo );

			if ( $plugin_domain == $textdomain ) {
  			if ( file_exists( $mo ) ) {
  				return $mo;
  			}
  			$pofile = str_replace( '.mo', '.po', $mofile );
  			if ( !file_exists( $mopath.$pofile ) ) {
          $bundled_file = GetYourBillPATH . '/languages/'. $mofile;
          if ( file_exists( $bundled_file ) ) {
            return $bundled_file;
          } else {
            return '';
          }
  			}
  		}

  		return $mopath.$mofile;
  	}


    function getyourbill_load_textdomain() {

      if ( function_exists( 'determine_locale' ) ) { // WP5.0+
        $locale = determine_locale();
      } else {
        $locale = is_admin() && function_exists( 'get_user_locale' ) ? get_user_locale() : get_locale();
      }
      $locale = apply_filters( 'plugin_locale', $locale, 'wc_getyourbill' );
      $dir    = trailingslashit( WP_LANG_DIR );

      $textdomains = array( 'wc_getyourbill' );

      foreach ( $textdomains as $textdomain ) {
        unload_textdomain( $textdomain );
        load_textdomain( $textdomain, $dir . 'getyourbill/wc_getyourbill-' . $locale . '.mo' );
        load_textdomain( $textdomain, $dir . 'plugins/getyourbill/wc_getyourbill-' . $locale . '.mo' );
        load_plugin_textdomain( $textdomain, false, dirname( plugin_basename(__FILE__) ) . '/languages' );
      }


    }

		function custom_admin_js() {
			global $wpdb;
			if( is_user_logged_in() && is_admin() ){
				$getyorbill_all_tax = array();
				$get_list_WC_Tax = WC_Settings_GetyourbillTabs::get_list_WC_Tax();
				foreach ( $get_list_WC_Tax[0] as $key => $taxes ) {
					if( count($taxes) >0  ){
						foreach ( $taxes as $tax ) {
							$q = $wpdb->get_var( "SELECT ID FROM ".$wpdb->posts." WHERE post_excerpt LIKE '".$tax->tax_rate_id."'" );
							if( $q !== null ){
								$post = get_post($q);
								if( !is_wp_error( $post ) ) {
									$getyorbill_all_tax[] = array(
										"id" => $post->ID,
										"edit" => false,
										"tax" => $post->post_excerpt,
										"gyb_tax" => $post->post_content,
										"title_tax" => WC_Settings_GetyourbillTabs::get_name_tax($post->post_excerpt, $get_list_WC_Tax[1]),
										"title_gyb_tax" => WC_Settings_GetyourbillTabs::get_name_gyb_tax($post->post_content, $get_list_WC_Tax[1]),
									);
								}
							}else{
								$getyorbill_all_tax[] = array(
									"id" => 0,
									"edit" => true,
									"tax" => $tax->tax_rate_id,
									"gyb_tax" => "",
									"title_tax" => WC_Settings_GetyourbillTabs::get_name_tax($tax->tax_rate_id, $get_list_WC_Tax[1]),
									"title_gyb_tax" => "",
								);
							}
						}
					}
				}
				?>
				<script type="text/javascript">
					var getyorbill_all_tax = <?php echo json_encode($getyorbill_all_tax, JSON_FORCE_OBJECT); ?>;
				</script>
				<?php
			}
		}

		function getyourbill_add_tax() {
			check_ajax_referer( 'getyourbill_get_campi_by_user', 'getyourbill_nonce' );
			$data = isset($_POST['data'])?WC_Settings_GetyourbillTabs::prepara_object_struttura($_POST["data"]):array();
			$res = array("error" => "missing data", "mess" => __("Dati mancanti", 'wc_getyourbill'));
			if( !isset($data['id']) || !isset($data['tax']) ){
				$res = array("error" => "missing data", "mess" => __("Riprovare", 'wc_getyourbill'));
			}
			$id = intval($data['id']);
			$gyb_tax = isset($data['gyb_tax'])?$data['gyb_tax']:"";
			$get_list_WC_Tax = WC_Settings_GetyourbillTabs::get_list_WC_Tax();
			if( $id > 0 && $gyb_tax === "-1" ){
				$r = wp_delete_post($id, true );
				if( $r !== false && !is_null($r) ){
					$res = array( "success" => true, "item" => 0, "action" => "add", "title_tax" => WC_Settings_GetyourbillTabs::get_name_tax($data['tax'], $get_list_WC_Tax[1]), "title_gyb_tax" => "", "tax" => $data['tax'], "gyb_tax" => "" );
				}
			}else if( $id === 0 ){
				$args_item = array(
					'post_title' => "",
					'post_type' => GetYourBillImposta,
					'post_excerpt' => $data['tax'],
					'post_content' => $data['gyb_tax'],
				);
				$item_response = wp_insert_post( wp_slash($args_item));
				if ( !is_wp_error($item_response) ){
					$res = array( "success" =>  true, "item" => $item_response, "action" => "add", "title_tax" => WC_Settings_GetyourbillTabs::get_name_tax($data['tax'], $get_list_WC_Tax[1]), "title_gyb_tax" => WC_Settings_GetyourbillTabs::get_name_gyb_tax($data['gyb_tax'], $get_list_WC_Tax[1]), "tax" => $data['tax'], "gyb_tax" => $data['gyb_tax'] );
				}
			}else if( $id > 0 ){
				$my_post = array(
					  'ID' => $id,
					  'post_type' => GetYourBillImposta,
					  'post_excerpt' => $data['tax'],
					  'post_content' => $data['gyb_tax'],
				);
				$item_response = wp_update_post( $my_post );
				if ( !is_wp_error($item_response) ){
					$res = array("success" => true, "item" => $item_response, "action" => "edit", "title_tax" => WC_Settings_GetyourbillTabs::get_name_tax($data['tax'], $get_list_WC_Tax[1]), "title_gyb_tax" => WC_Settings_GetyourbillTabs::get_name_gyb_tax($data['gyb_tax'], $get_list_WC_Tax[1]),"tax" => $data['tax'], "gyb_tax" => $data['gyb_tax']);
				}
			}
			wp_send_json($res);
		}

		function GetYourBillImpostType() {
			register_post_type( GetYourBillImposta,
				array(
					'public' => false,
					'publicly_queryable' => false,
					'exclude_from_search' => false,
					'show_ui' => false,
					'query_var' => false,
					'capability_type' => 'page',
					'hierarchical' => false,
				)
			);
			flush_rewrite_rules();
		}


		function getyourbill_admin_style() {
			wp_enqueue_style('getyourbill_admin_style', GetYourBillURL.'assets/css/admin/admin-style.css');
		}

		function getyourbill_register_activation_hook() {
			if ( class_exists('WooCommerce') ){
				$this->WC_Settings_GetyourbillTabs->registre_method_pre_pauments_gateways();
				$cron_key = wp_generate_password(20, false);
				$cron_key_wp = get_option( "getyourbill_settings_cron_key" );
				if( empty($cron_key_wp) ){
					update_option( "getyourbill_settings_cron_key" , $cron_key );
				}
			}
		}
		function getyourbill_register_deactivation_hook() {

		}

		public function getyourbill_is_schedule( $k = "") {
			return ( get_option( "getyourbill_settings_cron_key" ) == $k );
		}

		public function getyourbill_do_schedule( ) {
			$app = new \models\GetyourbillApp();
			$app->autosedbugs();
			$app->autostatus($this->WC_Settings_GetyourbillTabs);
			return "do_schedule";
		}



		function getyourbill_for_setting_up_scripts() {
			wp_register_style('getyourbill_style_front', plugin_dir_url(__FILE__) . 'assets/css/style.css');
			wp_register_script ('getyourbill_script_front', plugin_dir_url(__FILE__) . 'assets/js/script.js', array(), $this->vs, true);
			wp_enqueue_style('getyourbill_style_front');
			wp_enqueue_script('getyourbill_script_front');
		}

		function getyourbill_get_campi_by_user() {
			check_ajax_referer( 'getyourbill_get_campi_by_user', 'getyourbill_nonce' );
			$resonse = array( "error" => "" );
			if( isset($_GET["id"]) ){
				$user_id = $_GET["id"];
				$var = $this->WC_Settings_GetyourbillTabs->get_type_user_account($user_id);
				$resonse = array("success" => $var, "user" => $user_id );
			}
			wp_send_json($resonse);
		}

		function getyourbill_get_get_yourbill_user_info_by() {
			check_ajax_referer( 'getyourbill_get_campi_by_user', 'getyourbill_nonce' );
			$resonse = array( "error" => "" );
			$pi = isset($_GET["pi"])?$_GET["pi"]:"";
			$cf = isset($_GET["cf"])?$_GET["cf"]:"";
			$bilid = isset($_GET["bilid"])?$_GET["bilid"]:"";
			$country = isset($_GET["country"])?$_GET["country"]:"IT";
			$paid = isset($_GET["paid"])?$_GET["paid"]:"";
			if( $pi != "" || $cf != "" || $bilid != "" || $paid != "" ){

				if( $pi != "" && !$this->WC_Settings_GetyourbillTabs::is_pi($pi) ){
					$resonse = array( "error" => "missing" , "mess" => __( GetYourBill_Messaggi_Warning["pi_non_valida"], 'wc_getyourbill')  );
				}else if( $cf != "" && !$this->WC_Settings_GetyourbillTabs::is_cf($cf) ){
					$resonse = array( "error" => "missing" , "mess" => __( GetYourBill_Messaggi_Warning["cf_non_valida"], 'wc_getyourbill')  );
				}else if( $bilid != "" && !$this->WC_Settings_GetyourbillTabs::is_gid($bilid) ){
					$resonse = array( "error" => "missing" , "mess" => __( GetYourBill_Messaggi_Warning["bilid_non_valida"], 'wc_getyourbill')  );
				}else if( $paid != "" && !$this->WC_Settings_GetyourbillTabs::is_pa($paid) ){
					$resonse = array( "error" => "missing" , "mess" => __( GetYourBill_Messaggi_Warning["paid_non_valida"], 'wc_getyourbill')  );
				}else{
					$api = new \models\APIGetyourbill();
					$info = array();
					$info = $api->get_anagrafiche($bilid, $pi, $cf, $country, $paid);
					$info_ok = false; $ind = 0;
					foreach ( $info as $key => $val ) {
						if($val != ""){
							$ind++;
						}
						if( $ind > 2 ){
							$info_ok = true;
						}
					}
					foreach ( GetYourBillRefer as $key => $val ) {
						if( !array_key_exists($key,  $info) ){
							$info[$key] = "";
						}
					}
					if( $info_ok ){
						$resonse = array( "success" => $info, "data_refer" => $this->WC_Settings_GetyourbillTabs->data_refer, "mess" => __( GetYourBill_altro["dati_autocomplete_success"], 'wc_getyourbill') );
					}else{
						$resonse = array( "error" => "missing" , "mess" => __( GetYourBill_altro["dati_autocomplete_missing"], 'wc_getyourbill')  );
					}
				}
			}else{
				$resonse = array( "error" => "campi", "mess" => __( GetYourBill_Messaggi_Warning["almenu_uno_dei_campi"], 'wc_getyourbill') );
			}
			wp_send_json($resonse);
		}

		function getyourbill_checked_manual(){
			$remote = wp_remote_get( GetYourBillUpdateUrl.'info.json', array(
				'timeout' => 10,
				'headers' => array(
					'Accept' => 'application/json'
				) )
			);
			if ( !is_wp_error( $remote ) && isset( $remote['response']['code'] ) && $remote['response']['code'] == 200 && !empty( $remote['body'] ) ) {
				delete_transient( 'getyourbill_upgrade_'.$this->id );
				$remote_b = json_decode( $remote['body'] );

				if( $remote_b && version_compare( $this->vs, $remote_b->version, '<' ) && version_compare($remote_b->requires, get_bloginfo('version'), '<' ) ) {
					$res = new stdClass();
					$res->slug = $this->id;
					$res->plugin = 'getyourbill/getyourbill.php';
					$res->new_version = $remote_b->version;
					$res->version = $remote_b->version;
					$res->tested = $remote_b->tested;
					$res->package = $remote_b->download_url;
					set_transient( 'getyourbill_upgrade_'.$this->id, $remote_b, GetYour24H );
				}
			}
			wp_clean_plugins_cache();
			return;
		}

		function getyourbill_push_update( $transient ){
			if ( empty($transient->checked ) ) {
					return $transient;
				}

			if( false == $remote = get_transient( 'getyourbill_upgrade_'.$this->id ) ) {
				$remote = wp_remote_get( GetYourBillUpdateUrl.'info.json', array(
					'timeout' => 10,
					'headers' => array(
						'Accept' => 'application/json'
					) )
				);
				if ( !is_wp_error( $remote ) && isset( $remote['response']['code'] ) && $remote['response']['code'] == 200 && !empty( $remote['body'] ) ) {
					set_transient( 'getyourbill_upgrade_'.$this->id, json_decode( $remote["body"] ), GetYour24H );
          $remote =  json_decode( $remote['body'] );
				}else{
          $remote = null;
        }
			}

			if( $remote && !is_null($remote) ) {
				if( $remote && version_compare( $this->vs, $remote->version, '<' ) && version_compare($remote->requires, get_bloginfo('version'), '<' ) ) {
					$res = new stdClass();
					$res->slug = $this->id;
					$res->plugin = 'getyourbill/getyourbill.php';
					$res->new_version = $remote->version;
					$res->version = $remote->version;
					$res->tested = $remote->tested;
					$res->package = $remote->download_url;
					$transient->response[$res->plugin] = $res;
				}
			}
			return $transient;


		}

		function getyourbill_after_update( $upgrader_object, $options ) {
			if ( $options['action'] == 'update' && $options['type'] === 'plugin' )  {
				delete_transient( 'getyourbill_upgrade_'.$this->id );
			}
		}

		function getyourbill_plugin_info( $res, $action, $args ){

			if( $action !== 'plugin_information' )
				return false;

			if( $this->id !== $args->slug )
				return $res;

			if( false == $remote = get_transient( 'getyourbill_upgrade_'.$this->id ) ) {
				$remote = wp_remote_get( GetYourBillUpdateUrl.'info.json', array(
					'timeout' => 10,
					'headers' => array(
						'Accept' => 'application/json'
					) )
				);
				if ( !is_wp_error( $remote ) && isset( $remote['response']['code'] ) && $remote['response']['code'] == 200 && !empty( $remote['body'] ) ) {
					set_transient( 'getyourbill_upgrade_'.$this->id, json_decode( $remote['body'] ), GetYour24H ); // 12 hours cache
        }else{
          $remote = null;
        }
			}

			if( $remote && !is_null($remote) ) {
				$remote =  $remote;
				$res = new stdClass();
				$res->name = $remote->name;
				$res->slug = $this->id;
				$res->version = $remote->version;
				$res->tested = $remote->tested;
				$res->requires = $remote->requires;
				$res->author =  $remote->author; // I decided to write it directly in the plugin
				$res->author_profile =  $remote->author_profile; // WordPress.org profile
				$res->download_link = $remote->download_url;
				$res->trunk = $remote->download_url;
				$res->last_updated = $remote->last_updated;
				$res->sections = array(
					'description' => $remote->sections->description, // description tab
					'installation' => $remote->sections->installation, // installation tab
					'changelog' => $remote->sections->changelog, // changelog tab
				);

				if( !empty( $remote->sections->screenshots ) ) {
					$res->sections['screenshots'] = $remote->sections->screenshots;
				}

				if( !empty( $remote->banner ) ) {
					$res->banners = array(
						'low' => $remote->banner,
						'high' => $remote->banner_high
					);
				}
				return $res;
			}
			return false;

		}


    function getyourbill_meta_box_markup($post)
    {
     ?>
     <div>
         <textarea style="width: 100%;" name="getyourbill-box-text"><?php echo get_post_meta($post->ID, "_getyourbill-box-text", true); ?></textarea>
     </div>
     <?php
    }

    function getyourbill_save_postdata( $post_id ) {
        if ( array_key_exists( 'getyourbill-box-text', $_POST ) ) {
            update_post_meta(
                $post_id,
                '_getyourbill-box-text',
                $_POST['getyourbill-box-text']
            );
        }
    }

    function add_getyourbill_meta_box()
    {
        add_meta_box("getyourbill-meta-box", __("Descrizione prodotto Fatturazione elettronica", "wc_get_your_bill"), array( $this, "getyourbill_meta_box_markup"), "product");
    }


	}
    $GetYourBill = new GetYourBill();

endif;
