<?php
namespace models;
if ( !defined('GetYourBill') || !defined('GetYourBillApiUrl')) {
    header('Status: 403 Forbidden');
    header('HTTP/1.1 403 Forbidden');
    exit();
}

	class APIGetyourbill
	{
		public static $access_token = "";
		public static $refresh_token = "";
		public static $live_test_mode = "no";
		public static $is_valid_refresh_token = "";
		public static $call_url_api = GetYourBillApiUrl;
		public static $timeout = 100;
		public function __construct() {
			self::$live_test_mode = \models\GetyourbillApp::get_info("config_isonline", 'yes');
			self::$refresh_token = \models\GetyourbillApp::get_info( "apikey".(( self::$live_test_mode !== "yes" )?"":"_test") );
			self::$is_valid_refresh_token = \models\GetyourbillApp::get_info("isokkey");
      self::$call_url_api = GetYourBillApiUrl;

			if( self::$is_valid_refresh_token === "success" ){
				self::$access_token = self::get_access_token();
			}
		}

		public function get_info_getyourbill(){
			$res = $this->get_("Device/Code", array(), true, "GET");
			if( is_array($res) && array_key_exists("license", $res) ){
				return $res;
			}
			return null;
		}

		public function veriffica_access_token($refresh_token_param = null, $work_mode_param = "live"){

      $work_mode = (( self::$live_test_mode !== "yes" )?"":"_test");
      if( is_null($refresh_token_param) ){
  			$json = array(
  				"token" => self::$refresh_token
  			);
      }else{
        self::set_error_log( "Inizio verifica ".$work_mode_param." key " );
  			$json = array(
  				"token" => $refresh_token_param
  			);
        $work_mode = $work_mode_param;

        if( $work_mode == "test"  ){
          self::$call_url_api = GetYourBillApiUrlTEST;
        }else{
          self::$call_url_api = GetYourBillApiUrlLIVE;
        }

      }
			$res = $this->get_("token", $json, null );

      self::set_error_log( "Inizio print_r  ".print_r($json, true) );
      self::set_error_log( "Inizio res  ".print_r($res, true) );

			if( is_array($res) && array_key_exists("access_token", $res) && array_key_exists("refresh_token", $res) ){
  			self::$access_token = $res["access_token"];
				self::set_access_token("access_token".$work_mode, $res["access_token"]);
				return true;
			}else{
				return false;
			}
		}

		public function put_invoce_number( $docDate = "", $recoverCode = "", $transactionId = "", $completeDocNumber = "", $docPDF = "" ){

			$JSON = array(
				"docDate" => $docDate,
				"recoverCode" => $recoverCode,
				"transactionId" => $transactionId,
				"completeDocNumber" => $completeDocNumber,
				"docPdf" => $docPDF,
			);
			return $this->get_("Doc/Pdf", $JSON, true, "PUT");
		}




		public function get_invoce_number( $docDate = "", $recoverCode = "", $transactionId = ""){

			$JSON = array(
				"docDate" => $docDate,
				"recoverCode" => $recoverCode,
				"transactionId" => $transactionId,
			);
			$res = $this->get_("Doc/CompleteDocNumber/", $JSON, true);
			if( is_array($res) && array_key_exists("completeDocNumber", $res) ){
				return $res;
			}
			return null;
		}

		public function get_recoverCode( $invoice_bumber = 0){
			$res = $this->get_("Doc/RecoverCode/".$invoice_bumber, array(), true, "GET");
			if( is_array($res) && array_key_exists("recoverCode", $res) ){
				return $res["recoverCode"];
			}
			return null;
		}

		public function get_status_fattura( $recoverCode = "" ){
			return $res = $this->get_("Doc/State/".$recoverCode, array(), true, "GET");
		}

		public function annullamento_fattura( $recoverCode = "" ){
			//self::set_error_log( "DELETE DOC ".$recoverCode." date ".date("d-m-Y h:m") );
			return $res = $this->get_("Doc/".$recoverCode, array(), true, "DELETE");
		}

		public function send_fattura_json( $JSON = array() ){
			$res = $this->get_("Doc", $JSON, true);
			//self::set_error_log( "send_fattura_json ".print_r($JSON, true) );
			//self::set_error_log( "send_fattura_json   :".((is_array($res))?print_r( $res, true ):$res)  );
			if( $res === true){
				return true;
			}
			return $res;
		}


		public function get_anagrafiche( $Code = "", $VatNumber = "", $TaxCode = "", $country = "IT", $pa = "" ){
			//self::set_error_log( "get_anagrafiche ".$Code."  ".$VatNumber."  ".$TaxCode );
			$JSON = array(
        "Country" => $country,
			);
      if( $Code != "" ){
  			$JSON = array(
  				"Code" => $Code,
  			);
      }else if( $VatNumber != "" ){
  			$JSON = array(
  				"VatNumber" => $VatNumber,
          "Country" => $country,
  			);
      }else if( $TaxCode != "" ){
  			$JSON = array(
  				"TaxCode" => $TaxCode,
          "Country" => $country,
  			);
      }else if( $pa != "" ){
  			$JSON = array(
  				"IPACode" => $pa,
  			);
      }

      //self::set_error_log( "JSON  anagrafiche ".print_r($JSON, true) );
			$res = $this->get_('Location/Check', $JSON, true);
			foreach($res as $index => $val) {
				if( is_null($val) || $val == "0"){
					$res[$index] = "";
				}
			}
		//	self::set_error_log( "res  anagrafiche ".print_r($res, true) );
			return $res;
		}


		public static function get_access_token(){
      $work_mode = (( self::$live_test_mode !== "yes" )?"":"_test");
			$access_token = \models\GetyourbillApp::get_info("access_token".$work_mode);
			return ( !is_null($access_token) && !empty($access_token) )?$access_token:null;
		}

		public static function set_access_token($info = '', $val = ''){
			return \models\GetyourbillApp::set_info($info, $val);
		}

		public static function set_error_log( $mess = "" ){
			\models\GetyourbillApp::set_log( $mess );
		}

		public static function get_iva_by_numero( $n = 1, $iva = 10 ){
			$ris = ( $n ) * pow(10,2);
			$ris = round($ris);
			return number_format($ris / pow(10,2),2);
		}

		public static function fix_numero( $n = 1, $p = 6 ){

			$ris = ( $n ) * pow(10,2);
			$ris = round($ris);
			return number_format($ris / pow(10,2),$p, '.', '');
		}

		public function refresh_access_token(){
			// refresh_access_token

			$url_api = self::$call_url_api."token";
			$JSON = array(
				"token" => self::$refresh_token
			);
			if( trim($url_api) == ""){
				return json_decode(array(), true);
			}
			$dominio = $_SERVER["SERVER_NAME"];  // il dominio deve essere uguale al sito che chiama l'api altrimento l'api annulla la conessione
			$data_string = json_encode($JSON, JSON_FORCE_OBJECT);
			$ch = curl_init( $url_api );
			curl_setopt($ch, CURLOPT_REFERER,  $dominio);
			curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
			curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_TIMEOUT, self::$timeout);
			curl_setopt( $ch, CURLOPT_ENCODING, 'gzip,deflate');
			curl_setopt($ch, CURLOPT_HTTPHEADER,
				array(
					'Content-Type:application/json'
				)
			);
			$result = curl_exec($ch);
			$response_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
			curl_close($ch);
			if ( $response_code !== 200 ) {
				if( $response_code == 401 ){
					self::set_error_log( sprintf( __(GetYourBill_Messaggi_Error["api_refresh"], 'wc_getyourbill' ), print_r($result, true) ) );
					return false;
				}else{
					self::set_error_log( "Bad request :".print_r($result, true) );
					return false;
				}
			}
			$res = json_decode($result, true);
			if( is_array($res) && array_key_exists("access_token", $res) && array_key_exists("refresh_token", $res) ){
        $work_mode = (( self::$live_test_mode !== "yes" )?"":"_test");
  			self::$access_token = $res["access_token"];
				self::set_access_token("access_token".$work_mode, $res["access_token"]);
				self::set_access_token("apikey".$work_mode, $res["refresh_token"]);
				self::$refresh_token = $res["refresh_token"];
				self::$access_token = $res["access_token"];
				return true;
			}else{
				self::set_error_log( sprintf( __(GetYourBill_Messaggi_Error["api_response"], 'wc_getyourbill' ), print_r($result, true) ) );
				return false;
			}
		}


		public function get_support_key($k = null){
			if( is_null($k) ){
				return array();
			}
			$url_api = GetYourBillSupportUrl.GetYourBillSUPPORT."/".$k;
			$dominio = $_SERVER["SERVER_NAME"];
			$ch = curl_init( $url_api );
			curl_setopt($ch, CURLOPT_REFERER,  $dominio);
			curl_setopt( $ch, CURLOPT_ENCODING, 'gzip,deflate');
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_TIMEOUT, self::$timeout);
			curl_setopt($ch, CURLOPT_HTTPHEADER,
				array(
					'Accept: application/json',
					'Content-Type: application/json'
				)
			);
			$result = curl_exec($ch);
			$response_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
			curl_close($ch);
			if ( $response_code !== 200 ) {
				return null;
			}
			$res = json_decode($result, true);
			if( is_array($res) && array_key_exists("stato", $res) && $res["stato"] == 200 ){
				return $res["out"]["key"];
			}
			return null;
		}

		public function get_( $stringURL = "" , $JSON = array(), $header = null, $method = "POST"){

			// if( is_null(self::$access_token) ){
			// 	return array();
			// }
			$url_api = self::$call_url_api.$stringURL;
			if( trim($url_api) == ""){
				return array();
			}

      $lang = get_locale();
      $lang = explode( "_", $lang );
      $lang = strtolower($lang[0]);

      if( !in_array($lang, array("it", "en", "fr")) ){
        $lang = "en";
      }


			$dominio = $_SERVER["SERVER_NAME"];  // il dominio deve essere uguale al sito che chiama l'api altrimento l'api annulla la conessione

			$ch = curl_init( $url_api );
			curl_setopt($ch, CURLOPT_REFERER,  $dominio);
			curl_setopt($ch, CURLOPT_CUSTOMREQUEST, $method);
			if( $method == "POST" ||  $method == "PUT" ){
				curl_setopt($ch, CURLOPT_POSTFIELDS, wp_json_encode( $JSON ));
			}
			curl_setopt( $ch, CURLOPT_ENCODING, 'gzip,deflate');
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_TIMEOUT, self::$timeout);
			if( is_null($header) ){
				curl_setopt($ch, CURLOPT_HTTPHEADER,
					array(
						'Content-Type:application/json',
						'Accept-language: '.$lang
					)
				);
			}else{
				curl_setopt($ch, CURLOPT_HTTPHEADER,
					array(
						'Authorization: Bearer '.self::$access_token,
						'Accept: application/json',
						'Content-Type: application/json',
						'Accept-language: '.$lang
					)
				);
			}


			$result = curl_exec($ch);
      if ( curl_errno($ch) ) {
          $error = curl_error($ch);
    			curl_close($ch);
  				return array("error" => $error, "code" => 0 );
      } else {
  			$response_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
  			curl_close($ch);
  			if ( $response_code !== 200 ) {
  				if(array_key_exists("docPdf", $JSON))
  					$JSON["docPdf"] = "eliminato per peso";
  				if ( $response_code == 204 ) {
  					return true; // Response Status in caso di successo per invio della fattura al panel nel formato JSON
  				}else if( $response_code == 400 ){
  					self::set_error_log(  sprintf( __(GetYourBill_Messaggi_Error["api_badrequest"], 'wc_getyourbill' ) , print_r($result, true), $response_code) );
  					return array("error" => $result, "code" => $response_code);
  				}else if( $response_code == 401 ){
  					if( $this->refresh_access_token() ){
  						return $this->get_($stringURL, $JSON, $header, $method );
  					}
  				}else{
  					self::set_error_log(  sprintf( __(GetYourBill_Messaggi_Error["api_curl_err"], 'wc_getyourbill' ), print_r($result, true), $stringURL, print_r($JSON, true), $response_code) );
  				}
  				return array("error" => $result, "code" => $response_code );
  			}
  			return @json_decode($result, true);
      }
		}


	}

?>
